<template lang="">
  <div class="card">
    <p class="card-header">
      <button class="btn w-100 text-start main-app-text-color" type="button" data-bs-toggle="collapse" data-bs-target="#collapseExample" aria-expanded="false" aria-controls="collapseExample">
        <b> Cost Detail <i class="bi bi-chevron-down ms-2" style="font-size: 1.2rem;"></i></b>
      </button>

    </p>
    <div class="collapse show" id="collapseExample">
      <div class="table-responsive">
        <table class="table">
          <thead class="bg-light">
            <tr>
              <th 
                scope="col" 
                data-toggle="tooltip" 
                data-placement="top" 
                title="Description"
              >
                Description
              </th>
              <th  
                scope="col"
                data-toggle="tooltip" 
                data-placement="top" 
                title="Quantity"
              >
                Qty
              </th>
              <th  
                scope="col"
                data-toggle="tooltip" 
                data-placement="top" 
                title="UOM"
              >
                UOM
              </th>
              <th  
                scope="col"
                data-toggle="tooltip" 
                data-placement="top" 
                title="Unit Price"
              >
                Unit Price
              </th>
              <th  
                scope="col"
                data-toggle="tooltip" 
                data-placement="top" 
                title="Discount"
              >
                Discount (%)
              </th>
              <th  
                scope="col"
                data-toggle="tooltip" 
                data-placement="top" 
                title="VAT"
              >
                VAT (%)
              </th>
              <th scope="col"><!-- Empty Space For Arrow--></th>
              <th  
                scope="col"
                data-toggle="tooltip" 
                data-placement="top" 
                title="Currency"
              >
                Currency
              </th>
              <th  
                scope="col"
                data-toggle="tooltip" 
                data-placement="top" 
                title="VAT Amount"
              >
                VAT Amount
              </th>
              <th  
                scope="col"
                data-toggle="tooltip" 
                data-placement="top" 
                title="Sub Total"
              >
                Sub Total
              </th>
              <th  
                scope="col"
                data-toggle="tooltip" 
                data-placement="top" 
                title="Total"
              >
                Total
              </th>
              <th  
                scope="col"
                data-toggle="tooltip" 
                data-placement="top" 
                title="Charge To"
              >
                Change To
              </th>
              <th scope="col"><!-- Action Buttons --></th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="(item, index) in mainData" :key="index" class="">
              <td scope="col">
                <input class="form-control  px-2 py-1" v-model="item.description" placeholder="Description"/>
              </td>
              <td scope="col">
                <input class="form-control  px-2 py-1" type="number" v-model.number="item.qty" placeholder="Qty" min="0" step="1" pattern="\d*" @keypress="IsNumber" style="width: 70px;"/>
              </td>
              <td scope="col">
                <v-select :options="$store.state.uom" v-model="item.uom"/>
              </td>
              <td scope="col">
                <input class="form-control  px-2 py-1" type="number" v-model.number="item.unitPrice" placeholder="Unit Price" min="0" step="1" pattern="\d*" @keypress="IsNumber" style="width: 70px;"/>
              </td>
              <td scope="col">
                <input class="form-control  px-2 py-1" type="number" v-model.number="item.discount" placeholder="Discount" min="0" max="100" step="1" pattern="\d*" @keypress="IsNumberPercentage($event, item.discount)" style="width: 70px;"/>
              </td>
              <td scope="col">
                <input class="form-control  px-2 py-1" type="number" v-model.number="item.vat" placeholder="VAT" min="0" max="100" step="1" pattern="\d*"
                @keypress="IsNumberPercentage($event, item.vat)" style="width: 70px;"/>
              </td>
              <td scope="col text-center"><i class="bi bi-arrow-right text-muted m-auto"></i></td>
              <td scope="col">
                <v-select :options="$store.state.currency" v-model="item.currency"/>
              </td>
              <td scope="col">
                {{item.vatAmount}}
              </td>
              <td scope="col">
                {{item.subTotal}}
              </td>
              <td scope="col">
                {{item.total}}
              </td>
              <td scope="col">
                <v-select :options="$store.state.chargeTo" v-model="item.chargeTo"/>
              </td>
              <td><button @click="deleteItem(index)" class="btn btn-light"><i class="bi bi-dash text-muted"></i></button></td>
            </tr>
            <tr class="detail-summary">
              <td class="align-middle" scope="col" rowspan="2" colspan="7">
                Exchange Rate 1 USD = <input 
                  class="form-control px-2 py-1" 
                  type="number" 
                  v-model.number="exchangeRate" 
                  placeholder="Qty" 
                  min="0" 
                  step="1" 
                  pattern="\d*" 
                  @keypress="IsNumber" 
                  style="width: 70px;display: inline;"/> 
                AED
              </td>
              <td class="bg-light" scope="col">AED in Total</td>
              <td class="bg-light" scope="col">0.00</td>
              <td class="bg-light" scope="col">0.00</td>
              <td class="bg-light" scope="col">0.00</td>
              <td class="border border-0" scope="col"></td>
              <td class="border border-0 align-middle" rowspan="2" scope="col">
                <button class="btn btn-primary" @click="addItem()"><i class="bi bi-plus-lg"></i></button>
              </td>
            </tr>
            <tr>
              <td class="bg-light" scope="col">AED in Total</td>
              <td class="bg-light" scope="col">0.00</td>
              <td class="bg-light" scope="col">0.00</td>
              <td class="bg-light" scope="col">0.00</td>
              <td class="border border-0" scope="col"></td>
            </tr>
          </tbody>
        </table>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  data() {
    return {
      dummyMap:{
        description:'',
        qty:null,
        uom:'SHP',
        unitPrice:null,
        discount:0,
        vat:0,
        currency:'USD',
        vatAmount:0,
        subTotal:0,
        total:0,
        chargeTo:null
      },

      dummyData:[
        {
          description:'Desc1',
          qty:null,
          uom:'SHP',
          unitPrice:null,
          discount:0,
          vat:0,
          currency:'USD',
          vatAmount:0,
          subTotal:0,
          total:0,
          chargeTo:null
        },
        {
          description:'Desc2',
          qty:null,
          uom:'SHP',
          unitPrice:null,
          discount:0,
          vat:0,
          currency:'USD',
          vatAmount:0,
          subTotal:0,
          total:0,
          chargeTo:null
        }
      ],

      dummyOption:[
        "Abc",
        "Bca"
      ],

      exchangeRate:0,

      mainData:[]
    }
  },
  
  computed:{
    // mainData(){
    //   return []
    // }
  },

  mounted(){
    // this.mainData = this.dummyData
  },

  methods: {
    addItem(){
      // this.mainData.push(this.dummyMap)
      this.mainData.push({
        vatAmount: '0.00',
        subTotal: '0.00',
        total: '0.00',
      })
    },
    deleteItem(index){
      this.mainData.splice(index,1)
    },
    IsNumber($event) {
      //console.log($event.keyCode); //keyCodes value
      let keyCode = ($event.keyCode ? $event.keyCode : $event.which);
      if ((keyCode < 48 || keyCode > 57)) { // 46 is dot
          $event.preventDefault();
      }
    },

    IsNumberPercentage($event, value){
      let keyCode = ($event.keyCode ? $event.keyCode : $event.which);

      if (keyCode < 48 || keyCode > 57) { // 46 is dot
        $event.preventDefault();
      }else{
        let valueStr = ''
        if(value){
          valueStr = value.toString() + $event.key
        }else{
          valueStr = $event.key
        }

        if(parseInt(valueStr) > 100){
          $event.preventDefault();
        }
      }
      
    }
  },  
}
</script>

<style lang="">
  
</style>